#include <ttg.h>

int main(int argc, char **argv)
{
    ttg::initialize(argc, argv, -1);

    ttg::Edge<int, double> A_B("A->B");
    ttg::Edge<void, double> B_C0("B->C0");
    ttg::Edge<void, double> B_C1("B->C1");

    auto wa = ttg::make_tt<void>(
        []()
        {
            ttg::send<0>(0, 0.0);
            ttg::send<0>(1, 0.0); 
        },
        ttg::edges(), ttg::edges(A_B), "A", {}, {"to B"});

    auto wb = ttg::make_tt(
        [](const int &k,
           const double &a)
        {
            if(0 == k) ttg::sendv<0>(a);
            if(1 == k) ttg::sendv<1>(a); 
        },
        ttg::edges(A_B), ttg::edges(B_C0, B_C1),
        "B",
        {"from A"},
        {"to 1st input of C", "to 2nd input of C"});

    auto wc = ttg::make_tt<void>(
        [](const double &a,
           const double &b)
        { 
            ttg::print("Received ", a, "+", b); 
        },
        ttg::edges(B_C0, B_C1), ttg::edges(),
        "C", {"From B", "From B"}, {});

    ttg::make_graph_executable(wa);

    if (wa->get_world().rank() == 0)
        wa->invoke();

    ttg::execute();
    ttg::fence(wa->get_world());

    ttg::finalize();
    return EXIT_SUCCESS;
}
